const express = require('express');
const app = express();
const port = 3001;
var cors = require('cors');
const moment = require('moment');

//CORS middleware
app.use(express.json());
app.use(cors({
  methods: ['OPTIONS', 'GET','POST','DELETE','UPDATE','PUT','PATCH'],
  credentials: true,
  origin: ['http://localhost:3000', 'http://localhost:3002']
}));
app.get('/test', function (req, res, next) {
  res.send(
    {"success":true,"project":{"calendar":"business","hoursPerDay":8,"daysPerWeek":5,"daysPerMonth":20},"calendars":{"rows":[{"id":"business","name":"Business","intervals":[{"recurrentStartDate":"every weekday at 12:00","recurrentEndDate":"every weekday at 13:00","isWorking":false},{"recurrentStartDate":"every weekday at 17:00","recurrentEndDate":"every weekday at 08:00","isWorking":false}]}]},"tasks":{"rows":[{"id":128081,"name":"Task 1","startDate":"2021-09-30T07:00:00.000Z","endDate":"2021-10-04T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":14,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":1},{"id":129443,"name":"Milestone","startDate":"2021-09-26T07:00:00.000Z","endDate":"2021-10-17T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":46,"issummarytask":"T","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":2,"children":[{"id":128077,"name":"Task 2","startDate":"2021-09-26T07:00:00.000Z","endDate":"2021-09-27T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":10,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":3},{"id":128086,"name":"Task 4","startDate":"2021-10-04T07:00:00.000Z","endDate":"2021-10-04T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":4},{"id":128892,"name":"Task 5","startDate":"2021-10-11T07:00:00.000Z","endDate":"2021-10-17T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":35,"issummarytask":"F","note":"","canDel":true,"percentDone":0,"readOnly":false,"order":5}]},{"id":128079,"name":"Task 6","startDate":"2021-09-29T07:00:00.000Z","endDate":"2021-10-03T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":17,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":6},{"id":128121,"name":"Task 7","startDate":"2021-09-26T07:00:00.000Z","endDate":"2021-09-26T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1,"issummarytask":"F","note":"","canDel":false,"percentDone":100,"readOnly":true,"order":7},{"id":128852,"name":"Task 8","startDate":"2021-09-30T07:00:00.000Z","endDate":"2021-10-01T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":4.5,"issummarytask":"F","note":"","canDel":false,"percentDone":100,"readOnly":true,"order":8},{"id":129057,"name":"Task 9","startDate":"2021-10-03T07:00:00.000Z","endDate":"2021-10-04T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":4.5,"issummarytask":"F","note":"","canDel":false,"percentDone":100,"readOnly":true,"order":9},{"id":129058,"name":"Task 10","startDate":"2021-10-03T07:00:00.000Z","endDate":"2021-10-04T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":4.5,"issummarytask":"F","note":"","canDel":false,"percentDone":100,"readOnly":true,"order":10},{"id":129061,"name":"Task 11","startDate":"2021-10-03T07:00:00.000Z","endDate":"2021-10-03T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1.5,"issummarytask":"F","note":"","canDel":false,"percentDone":100,"readOnly":true,"order":11},{"id":129063,"name":"Task 12","startDate":"2021-10-03T07:00:00.000Z","endDate":"2021-10-03T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1.5,"issummarytask":"F","note":"","canDel":false,"percentDone":0,"readOnly":false,"order":12},{"id":129212,"name":"Task 13","startDate":"2021-10-04T07:00:00.000Z","endDate":"2021-10-04T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":3,"issummarytask":"F","note":"","canDel":true,"percentDone":0,"readOnly":false,"order":13},{"id":128080,"name":"Task 14","startDate":"2021-09-26T07:00:00.000Z","endDate":"2021-09-27T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":11,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":14},{"id":128082,"name":"Task 15","startDate":"2021-09-28T07:00:00.000Z","endDate":"2021-09-30T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":13,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":15},{"id":128085,"name":"Task 16","startDate":"2021-10-03T07:00:00.000Z","endDate":"2021-10-03T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":2,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":16},{"id":128083,"name":"Task 17","startDate":"2021-10-10T07:00:00.000Z","endDate":"2021-11-05T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":160,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":17},{"id":128087,"name":"Task 18","startDate":"2021-11-04T07:00:00.000Z","endDate":"2021-11-04T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":18},{"id":128089,"name":"Task 19","startDate":"2021-09-27T07:00:00.000Z","endDate":"2021-09-27T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":19},{"id":128078,"name":"Task 20","startDate":"2021-09-26T07:00:00.000Z","endDate":"2021-09-27T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":11,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":20},{"id":128084,"name":"Task 21","startDate":"2021-09-27T07:00:00.000Z","endDate":"2021-09-27T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":2,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":21},{"id":128088,"name":"Task 22","startDate":"2021-09-27T07:00:00.000Z","endDate":"2021-09-27T07:00:00.000Z","constrainttypeNS":"FIXEDSTART","constraintType":"startnoearlierthan","schedulingMode":"Fixed Effort","durationUnit":"hour","duration":1,"issummarytask":"F","note":null,"canDel":true,"percentDone":0,"readOnly":false,"order":22}]},"dependencies":{"rows":[{"id":"1_128079_128081","fromTask":128079,"toTask":128081,"lag":null,"successor":128081},{"id":"2_128080_128084","fromTask":128080,"toTask":128084,"lag":null,"successor":128084},{"id":"3_128082_128085","fromTask":128082,"toTask":128085,"lag":null,"successor":128085},{"id":"4_128081_128086","fromTask":128081,"toTask":128086,"lag":null,"successor":128086},{"id":"5_128078_128088","fromTask":128078,"toTask":128088,"lag":null,"successor":128088},{"id":"6_128077_128089","fromTask":128077,"toTask":128089,"lag":null,"successor":128089},{"id":"7_128083_128087","fromTask":128083,"toTask":128087,"lag":null,"successor":128087},{"id":"8_128121_128077","fromTask":128121,"toTask":128077,"lag":null,"successor":128077},{"id":"9_128121_128078","fromTask":128121,"toTask":128078,"lag":null,"successor":128078},{"id":"10_128121_128080","fromTask":128121,"toTask":128080,"lag":null,"successor":128080}]}}
  );
});
app.post('/assistant', function (req, res, next) {
  res.send({
    status: 200,
    assistant: [ "assistant1", "assistant2", "assistant3", "assistant4", "assistant5", "assistant6"]
  })
});
app.post('/sync', function (req, res, next) {
  //console.log(JSON.stringify(req.body));
  var rows_dependencies = [], rows_tasks;
  if(req.body.dependencies && req.body.dependencies.added)
    rows_dependencies = req.body.dependencies.added;
  if(req.body.tasks && req.body.tasks.added)
    rows_tasks = req.body.tasks.added;
  res.send({
      "id": 129324,
      "success"   : true,
      "requestId" : req.body.requestId,
      "revision"  : req.body.revision ? req.body.revision + 1 : 1,
      "dependencies": {
        "rows" : rows_dependencies
      },
      "tasks": {
        "rows": rows_tasks
      },
      //"error_msg": "have error",
      "msg": "Sync success"
  });
});
app.listen(port, () => {
  console.log(`Example app listening at http://localhost:${port}`);
});
